(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-window-token'), require('rxjs'), require('rxjs/operators'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-spotlight', ['exports', '@angular/core', 'ngx-window-token', 'rxjs', 'rxjs/operators', '@angular/common'], factory) :
    (global = global || self, factory(global['ngx-spotlight'] = {}, global.ng.core, global.ngxWindowToken, global.rxjs, global.rxjs.operators, global.ng.common));
}(this, (function (exports, core, ngxWindowToken, rxjs, operators, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var SpotlightService = /** @class */ (function () {
        function SpotlightService() {
            /** available spotlights list */
            this._targetMap = new Map();
        }
        /**
         * Registers the spotlight directive into the service
         * @param id - spotlight id
         * @param target - spotlight's directive reference
         */
        SpotlightService.prototype.register = function (id, target) {
            if (this._targetMap.has(id)) {
                throw new Error("The " + id + " spotlight is already registered!");
            }
            this._targetMap.set(id, target);
        };
        /**
         * All registred directive ids
         */
        SpotlightService.prototype.getIdlist = function () {
            return Array.from(this._targetMap.keys());
        };
        /**
         * Get SpotlightDirective instance by id
         * @param id - spotlight id
         */
        SpotlightService.prototype.getById = function (id) {
            return this._targetMap.get(id);
        };
        /**
         * Unregisters the spotlight directive from the service. Should be used in directive's `OnDestroy` hook
         * @param id - spotlight's id
         */
        SpotlightService.prototype.deregister = function (id) {
            this._targetMap.delete(id);
        };
        SpotlightService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function SpotlightService_Factory() { return new SpotlightService(); }, token: SpotlightService, providedIn: "root" });
        SpotlightService = __decorate([
            core.Injectable({
                providedIn: 'root',
            })
        ], SpotlightService);
        return SpotlightService;
    }());

    function capitalize(value) {
        return value.charAt(0).toUpperCase() + value.slice(1);
    }
    /**
     * Modifies the given layer's styles **by mutating it**
     * @param el - backdrop's layer HTML element
     * @param piece - piece of spotlight element
     */
    function getStyle(rects, piece, borderWidth, indent) {
        var left = rects.left - indent;
        var top = rects.top - indent;
        var right = rects.right + indent;
        var bottom = rects.bottom + indent;
        var width = rects.width + 2 * indent;
        var height = rects.height + 2 * indent;
        switch (piece) {
            case 'backdrop-top':
                return {
                    top: '0',
                    left: '0',
                    right: '0',
                    height: top + "px",
                };
            case 'backdrop-bottom':
                return {
                    top: bottom + "px",
                    left: '0',
                    right: '0',
                    bottom: '0',
                };
            case 'backdrop-left':
                return {
                    top: top + "px",
                    left: '0',
                    width: left + "px",
                    height: height + "px",
                };
            case 'backdrop-right':
                return {
                    top: top + "px",
                    left: right + "px",
                    right: '0',
                    height: height + "px",
                };
            case 'overlay':
                return {
                    top: top + "px",
                    left: left + "px",
                    width: width + "px",
                    height: height + "px",
                    position: 'fixed',
                    zIndex: '990',
                };
            case 'border-top':
                return {
                    borderTopStyle: 'solid',
                    top: top - borderWidth + "px",
                    left: left - borderWidth + "px",
                    height: borderWidth + "px",
                    width: width + 2 * borderWidth + "px",
                };
            case 'border-bottom':
                return {
                    top: bottom - borderWidth + "px",
                    left: left - borderWidth + "px",
                    height: borderWidth + "px",
                    width: width + 2 * borderWidth + "px",
                };
            case 'border-left':
                return {
                    top: top - borderWidth + "px",
                    left: left - borderWidth + "px",
                    height: height + 2 * borderWidth + "px",
                    width: borderWidth + "px",
                };
            case 'border-right':
                return {
                    top: top - borderWidth + "px",
                    left: right - borderWidth + "px",
                    height: height + 2 * borderWidth + "px",
                    width: borderWidth + "px",
                };
            default:
                throw new Error("Unexpected element " + piece);
        }
    }

    /**
     * Spotlight directive
     *
     * This lets you to spotlight certain elements
     * by placing 4 dark transparent divs around it
     */
    var SpotlightDirective = /** @class */ (function () {
        function SpotlightDirective(_spotlightService, _window, elementRef, _renderer, _zone) {
            this._spotlightService = _spotlightService;
            this.elementRef = elementRef;
            this._renderer = _renderer;
            this._zone = _zone;
            /** spotlight id */
            this.id = 'spotlight_at_' + Date.now();
            /** draw border around spotlight element */
            this.border = false;
            /** space around spotlight element */
            this.indent = 0;
            /** draw transparent overlay on spotlight element */
            this.overlay = false;
            /** highlight element after view init */
            this.auto = false;
            /** border width */
            this.borderWidth = 4;
            /** backdrop and overlay click event */
            this.spotlightClick = new core.EventEmitter();
            /** whether the directive is shown */
            this._isShown = false;
            /** destroy subject (pattern) */
            this._destroy$ = new rxjs.Subject();
            /** set of all created corresponding elements (backdrops, borders and overlay) */
            this._elementMap = new Map();
            /**
             * Set of listeners that should be "unlistened" on destroying
             * @see https://angular.io/api/core/Renderer2#listen
             */
            this._listenerSet = new Set();
            this._window = _window;
        }
        Object.defineProperty(SpotlightDirective.prototype, "isShown", {
            /** whether the spotlight is shown */
            get: function () {
                return this._isShown;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SpotlightDirective.prototype, "container", {
            /** main spotlight container */
            get: function () {
                return this._elementMap.get('container');
            },
            enumerable: true,
            configurable: true
        });
        SpotlightDirective.prototype.ngAfterViewInit = function () {
            this._spotlightService.register(this.id, this);
            if (this.auto) {
                this.show();
            }
        };
        /**
         * Shows the overlay
         * - Scrolls the page to the very top
         * - Places 4 overlays around the element
         */
        SpotlightDirective.prototype.show = function () {
            if (this._isShown) {
                return;
            }
            this._drawContainer();
            this._drawBackdrop();
            if (this.border) {
                this._drawBorder();
            }
            if (this.overlay) {
                this._drawOverlay();
            }
            this._watchWindowUpdate();
            this._isShown = true;
        };
        /**
         * Places container to document body
         */
        SpotlightDirective.prototype._drawContainer = function () {
            var container = this._renderer.createElement('div');
            this._renderer.addClass(container, 'spotlight__container'); // just for show class
            this._setStyles(container, {
                position: 'absolute',
                zIndex: '940',
                left: '0px',
                top: '0px',
                right: '0px',
                bottom: '0px',
                pointerEvents: 'none',
            });
            this._elementMap.set('container', container);
            this._renderer.appendChild(this._window.document.body, container);
        };
        /**
         * Places 4 backdrops around the elementRef
         */
        SpotlightDirective.prototype._drawBackdrop = function () {
            var e_1, _a;
            var _this = this;
            var _loop_1 = function (side) {
                var backdrop = "backdrop-" + side;
                var backdropEl = this_1._renderer.createElement('div');
                this_1._renderer.addClass(backdropEl, 'spotlight__backdrop'); // just for show class
                this_1._renderer.addClass(backdropEl, "spotlight__backdrop_" + side); // just for show class
                this_1._setStyles(backdropEl, {
                    position: 'fixed',
                    zIndex: '950',
                    display: 'block',
                    backgroundColor: "var(\n          --color__spotlight-backdrop_background,\n          rgba(52, 74, 94, 0.8)\n        )",
                });
                this_1._modifyPieceStyle(backdropEl, backdrop);
                this_1._listenerSet.add(this_1._renderer.listen(backdropEl, 'click', function (event) {
                    event.preventDefault();
                    _this.spotlightClick.emit({ piece: backdrop, mouse: event });
                }));
                this_1._elementMap.set(backdrop, backdropEl);
                this_1._renderer.appendChild(this_1.container, backdropEl);
            };
            var this_1 = this;
            try {
                for (var _b = __values(['top', 'bottom', 'left', 'right']), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var side = _c.value;
                    _loop_1(side);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        /**
         * Places 4 div around the spotlight to emulate stroke
         */
        SpotlightDirective.prototype._drawBorder = function () {
            var e_2, _a, _b;
            try {
                for (var _c = __values(['top', 'bottom', 'left', 'right']), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var side = _d.value;
                    var border = "border-" + side;
                    var borderEl = this._renderer.createElement('div');
                    this._renderer.addClass(borderEl, 'spotlight__border'); // just for show class
                    this._renderer.addClass(borderEl, "spotlight__border_" + side); // just for show class
                    this._setStyles(borderEl, (_b = {
                            position: 'fixed',
                            zIndex: '955',
                            pointerEvents: 'none',
                            borderRadius: '20px',
                            display: 'block',
                            borderColor: "var(\n          --color__spotlight-border,\n          #c9c9c9\n        )"
                        },
                        _b["border" + capitalize(side) + "Width"] = this.borderWidth + 'px',
                        _b["border" + capitalize(side) + "Style"] = 'solid',
                        _b));
                    this._modifyPieceStyle(borderEl, border);
                    this._elementMap.set(border, borderEl);
                    this._renderer.appendChild(this.container, borderEl);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_2) throw e_2.error; }
            }
        };
        /**
         * Watches for window scroll&resize and, when it occurs, modifies the layers styles
         */
        SpotlightDirective.prototype._watchWindowUpdate = function () {
            var _this = this;
            var updateHtmlElements = function () {
                var e_3, _a;
                try {
                    for (var _b = __values(_this._elementMap), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var _d = __read(_c.value, 2), piece = _d[0], layer = _d[1];
                        _this._modifyPieceStyle(layer, piece);
                    }
                }
                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_3) throw e_3.error; }
                }
            };
            this._zone.runOutsideAngular(function () {
                rxjs.merge(rxjs.fromEvent(window, 'scroll'), rxjs.fromEvent(window, 'resize'))
                    .pipe(operators.takeUntil(_this._destroy$))
                    .subscribe(function () { return updateHtmlElements(); });
            });
        };
        /**
         * Sets backdrop piece styles
         * @param element - the element to mutate
         * @param props - the limited set of CSS properties
         */
        SpotlightDirective.prototype._setStyles = function (element, props) {
            for (var prop in props) {
                if (props.hasOwnProperty(prop)) {
                    this._renderer.setStyle(element, prop, props[prop]);
                }
            }
        };
        /**
         * Modifies the given layer's styles **by mutating it**
         * @param el - backdrop's layer HTML element
         * @param piece - piece of spotlight element
         */
        SpotlightDirective.prototype._modifyPieceStyle = function (el, piece) {
            if (piece !== 'container') {
                var rects = this.elementRef.nativeElement.getBoundingClientRect();
                var style = getStyle(rects, piece, this.borderWidth, this.indent);
                this._setStyles(el, style);
            }
        };
        /**
         * Draws an invisible element over the spotlighted element from the DOM
         */
        SpotlightDirective.prototype._drawOverlay = function () {
            var _this = this;
            var overlay = this._renderer.createElement('div');
            this._renderer.addClass(overlay, 'spotlight__cover'); // just for show element
            this._modifyPieceStyle(overlay, 'overlay');
            this._listenerSet.add(this._renderer.listen(overlay, 'click', function (event) {
                event.preventDefault();
                _this.spotlightClick.emit({ piece: 'overlay', mouse: event });
            }));
            this._elementMap.set('overlay', overlay);
            this._renderer.appendChild(this.elementRef.nativeElement.parentElement, overlay);
        };
        /**
         * Removes the spotlight for this element
         */
        SpotlightDirective.prototype.hide = function () {
            if (!this._isShown) {
                return;
            }
            this._removeElements();
            this._destroy$.next();
            this._isShown = false;
        };
        /**
         * Removes the backdrop and the overlay elements from the DOM
         */
        SpotlightDirective.prototype._removeElements = function () {
            var e_4, _a, e_5, _b;
            try {
                for (var _c = __values(this._listenerSet), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var removeListener = _d.value;
                    removeListener();
                }
            }
            catch (e_4_1) { e_4 = { error: e_4_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_4) throw e_4.error; }
            }
            this._listenerSet.clear();
            try {
                for (var _e = __values(this._elementMap.values()), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var layer = _f.value;
                    layer.remove();
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                }
                finally { if (e_5) throw e_5.error; }
            }
            this._elementMap.clear();
        };
        SpotlightDirective.prototype.ngOnDestroy = function () {
            this._destroy$.next();
            this._destroy$.complete();
            this.hide();
            this._spotlightService.deregister(this.id);
        };
        SpotlightDirective.ctorParameters = function () { return [
            { type: SpotlightService },
            { type: undefined, decorators: [{ type: core.Inject, args: [ngxWindowToken.WINDOW,] }] },
            { type: core.ElementRef },
            { type: core.Renderer2 },
            { type: core.NgZone }
        ]; };
        __decorate([
            core.Input('ngxSpotlight')
        ], SpotlightDirective.prototype, "id", void 0);
        __decorate([
            core.Input()
        ], SpotlightDirective.prototype, "border", void 0);
        __decorate([
            core.Input()
        ], SpotlightDirective.prototype, "indent", void 0);
        __decorate([
            core.Input()
        ], SpotlightDirective.prototype, "overlay", void 0);
        __decorate([
            core.Input()
        ], SpotlightDirective.prototype, "auto", void 0);
        __decorate([
            core.Input()
        ], SpotlightDirective.prototype, "borderWidth", void 0);
        __decorate([
            core.Output()
        ], SpotlightDirective.prototype, "spotlightClick", void 0);
        SpotlightDirective = __decorate([
            core.Directive({
                selector: '[ngxSpotlight]',
                exportAs: 'spotlight',
            }),
            __param(1, core.Inject(ngxWindowToken.WINDOW))
        ], SpotlightDirective);
        return SpotlightDirective;
    }());

    /**
     * Spotlight directive.
     * It's used to highlight specific element on the page
     *
     * Usage:
     * ```html
     * <some-component ngxSpotlight></some-component>
     * ```
     */
    var NgxSpotlightModule = /** @class */ (function () {
        function NgxSpotlightModule() {
        }
        NgxSpotlightModule = __decorate([
            core.NgModule({
                declarations: [SpotlightDirective],
                imports: [common.CommonModule],
                exports: [SpotlightDirective]
            })
        ], NgxSpotlightModule);
        return NgxSpotlightModule;
    }());

    exports.NgxSpotlightModule = NgxSpotlightModule;
    exports.SpotlightDirective = SpotlightDirective;
    exports.SpotlightService = SpotlightService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-spotlight.umd.js.map
